#pragma once

#include "resource.h"

#define LOCAL_LOC	_T(".1251")
#define KLID_LOC	_T("00000419")

#define FILE_EXT_LOG	_T(".log")
#define FILENAME_LOG	_T("ChatClient.log")
#define FILE_EXT_INI	_T(".ini")
#define FILENAME_INI	_T("ChatClient.ini")

#define ERR_MSG_CAP_LOC	_T("Error")
#define ERR_MSG_CANNOTCREATE_LOC	_T("Can not create log-file.")

#define MAX_MSG_SIZE	1024
#define MAX_LEN_TIP		128

void InitBuffer(void);
void ShowData(HWND hWnd);
void UpdateControls(HWND hWnd);
void OnStartClick(HWND hWnd);
void OnSendClick(HWND hWnd);
void OnNetEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void OnClose(HWND hWnd);

INT_PTR CALLBACK Props(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT APIENTRY EditSubClsProcPort(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT APIENTRY EditSubClsProcHost(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void ReadSettings(LPCTSTR lpszFileName);
void WriteSettings(LPCTSTR lpszFileName);
bool ShowInTray(HWND hWnd);
bool ReleaseInTray(HWND hWnd);
