#pragma once
#include "SocketBase.h"

#define LEN_MSG_COMPLETED_LOC	MAX_HOST_LENGTH + 51 + 15 + 5	
#define FRM_MSG_COMPLETED_LOC	_T("@Initialize completed for '%s' with ip '%s' and port '%hu'")
#define LEN_MSG_ACCEPT	8 + LEN_BUFF_KEY
#define FRM_MSG_ACCEPT _T("@Accept %s")
#define LEN_MSG_CLOSE	8 + LEN_BUFF_KEY
#define FRM_MSG_CLOSE _T("@Closed %s")
#define LEN_MSG_WRITE	19 + LEN_BUFF_KEY + 20
#define FRM_MSG_WRITE _T("@To %s bytes sended: %d")
#define LEN_MSG_READ	23 + LEN_BUFF_KEY + 20
#define FRM_MSG_READ _T("@From %s bytes received: %d")

#define MAX_CAP_SIZE	15
#define BTN_CAP_START	_T("")
#define BTN_CAP_STOP	_T("")

#include <list>
using namespace std ;

class SocketServer : public SocketBase
{
public:
	SocketServer(void);
	virtual ~SocketServer(void);
	bool Initialize(HWND hWnd, int nPort, LPCTSTR lpRemoteHost = NULL);
	void Event_OnWSAAccept(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	void Event_OnWSANet(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	bool Close(HWND hWnd);
	bool WriteMsg(LPCTSTR lpszMsg);
	DWORD Send(HWND hWnd, LPCTSTR lpszMsg);
	int GetClientsCount(void);
	bool m_bAutoStart;
	_TCHAR m_BuffMsg[RECV_BUFF_SIZE];
protected:
	typedef struct _CLIENTSOCKET
	{
		SOCKET client_socket;
		SOCKADDR_IN client_socket_arrd;
	} CLIENTSOCKET, *LPCLIENTSOCKET;
	typedef list<CLIENTSOCKET> LIST_CLIENTSOCKET, *LPLIST_CLIENTSOCKET;
	LIST_CLIENTSOCKET m_list_client_sockets;
	bool m_bAcceptMode;
};
