#pragma once

#include "resource.h"

#define LOCAL_LOC		_T(".1251")
#define KLID_LOC		_T("00000419")

#define NULTEX_NAME		_T("{FB3BE9E1-9C28-4884-95B0-4A3446CDDCDC}")

#define FILE_EXT_LOG	_T(".log")
#define FILENAME_LOG	_T("ChatServer.log")
#define FILE_EXT_INI	_T(".ini")
#define FILENAME_INI	_T("ChatServer.ini")

#define ERR_MSG_CAP_LOC	_T("Error")
#define ERR_MSG_CANNOTCREATE_LOC	_T("Can not create log-file.")

#define INF_MSG_NOCONNECTIONS_LOC	_T("  .")
#define INF_MSG_CAPTION_LOC			_T(":")
 
#define MAX_MSG_SIZE	1024
#define MAX_LEN_TIP		128

void InitBuffer(void);
void ShowData(HWND hWnd);
void UpdateControls(HWND hWnd);
void OnStartClick(HWND hWnd);
void OnSendClick(HWND hWnd);
void OnAcceptEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void OnNetEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void OnClose(HWND hWnd);

INT_PTR CALLBACK Props(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT APIENTRY EditSubclassProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void ReadSettings(LPCTSTR lpszFileName);
void WriteSettings(LPCTSTR lpszFileName);
bool ShowInTray(HWND hWnd);
bool ReleaseInTray(HWND hWnd);

