// FileLog.h: interface for the CFileLog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RFILELOG_H__47835386_0BCA_11D4_9E83_009027A4D0CE__INCLUDED_)
#define AFX_RFILELOG_H__47835386_0BCA_11D4_9E83_009027A4D0CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <time.h>

#define DATETIME_STR_LEN	30
#define TIME_STR_LEN		13
#define DATETIME_FORMAT		_T("%#c")
#define TIME_FORMAT			_T("%X.%S")
#define STR_ENDLINE			"\r\n"
#define LEN_ENDLINE			2

class CFileLog  
{
public:
	CFileLog();
	CFileLog(LPCTSTR lpszLogFile);
	virtual ~CFileLog();
	BOOL Flush();
	BOOL IsOpen();
	void Close();
	BOOL Open();
	BOOL ResetFileName(LPCTSTR lpszLogFile);
	BOOL WriteStr(LPCTSTR lpszStr);
	BOOL WriteLog(LPCTSTR lpszStr);
	_TCHAR m_szLogFile[MAX_PATH];
	bool ShowFile();
protected:
	HANDLE m_hFile;
};

#endif // !defined(AFX_RFILELOG_H__47835386_0BCA_11D4_9E83_009027A4D0CE__INCLUDED_)
