#pragma once
#include "SocketBase.h"
#include <Ws2tcpip.h>

#define MAX_MSG_BUFF_LEN	SO_MAX_MSG_SIZE 
#define LEN_MSG_COMPLETED_REM	2*MAX_HOST_LENGTH + 73 + 2*15	
#define FRM_MSG_COMPLETED_REM	_T("@Initialize completed from '%s' with ip '%s' to '%s' with ip '%s' through port '%hu'")
#define LEN_MSG_CLOSE_REM	8 + LEN_BUFF_KEY
#define FRM_MSG_CLOSE_REM _T("@Closed %s")
#define LEN_MSG_WRITE_REM	19 + LEN_BUFF_KEY + 20
#define FRM_MSG_WRITE_REM _T("@To %s bytes sended: %d")
#define LEN_MSG_READ_REM	23 + LEN_BUFF_KEY + 20
#define FRM_MSG_READ_REM _T("@From %s bytes received: %d")

#define MAX_CAP_SIZE	20
#define BTN_CAP_CONNECT	_T("")
#define BTN_CAP_DISCONNECT	_T("")

class SocketClient : public SocketBase
{
public:
	SocketClient(void);
	virtual ~SocketClient(void);
	bool Initialize(HWND hWnd, int nPort, LPCTSTR lpRemoteHost = NULL);
	void Event_OnWSANet(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	bool Close(HWND hWnd);
	bool WriteMsg(LPCTSTR lpszMsg);
	DWORD Send(LPCTSTR lpszMsg);
	bool GetRemoteHostName(LPTSTR lpszRemoteHostName, int& nLength);
	bool SetRemoteHostName(LPTSTR lpszRemoteHostName, int nLength);
	_TCHAR m_BuffMsg[MAX_MSG_BUFF_LEN];
	bool m_bAutoStart;
protected:
	_TCHAR m_szSocketKey[LEN_BUFF_KEY];
	_TCHAR m_szRemoteHost[MAX_HOST_LENGTH];
};
